package rs2gprs;
import javax.microedition.io.*;
import java.io.DataInputStream;
import java.io.DataOutputStream;

public class WorkerThread extends Thread {
	
	SocketConnection sc;
	Tc65SerialPort tc65SerialPort;
	
public WorkerThread(SocketConnection s, Tc65SerialPort tc) {
	sc = s;
	tc65SerialPort = tc;
	}

public void run(){
	tc65SerialPort.serialOut("WorkerThread:run()\r\n");
	
	try {
		tc65SerialPort.serialOut("Connection from: " + sc.getAddress()
				+ ":" + sc.getPort() + "\r\n");
	} catch (Exception e) {
		tc65SerialPort.serialOut("ProcessSocketConnection: failed to get remote addr: excp: " + e.getMessage() + "\r\n");
	}		
	
	try {
		// Set application specific hints on the socket.
		sc.setSocketOption(SocketConnection.DELAY, 0);
		sc.setSocketOption(SocketConnection.LINGER, 0);
		sc.setSocketOption(SocketConnection.KEEPALIVE, 0);
		sc.setSocketOption(SocketConnection.RCVBUF, 128);
		sc.setSocketOption(SocketConnection.SNDBUF, 128);
	} catch (Exception e) {
		tc65SerialPort.serialOut("WorkerThread: sc.setSocketOption() excp: " + e.getMessage() + "\r\n");
	}	   
	try {
		// Get the input stream of the connection.
		tc65SerialPort.serialOut("WorkerThread: opening DataInputStream\r\n");
		DataInputStream is = sc.openDataInputStream();
		// Get the output stream of the connection.
		tc65SerialPort.serialOut("WorkerThread: opening DataOutputStream\r\n");
		DataOutputStream os = sc.openDataOutputStream();
		// Read the input data until 1s timeout happens.
		String result = new String("<html><body><b>Modem received:</b><br>");//is.readUTF();
		int timeout = (int)System.currentTimeMillis();
		while((int)System.currentTimeMillis() - timeout < 3000)
		{
			if(is.available() > 0)
			{
				char b = (char)is.read();
				// Convert special chars into HTML
				switch(b)
				{
				case 0x0d:
					result += "<br>";
					break;
				case 0x0a:
					break;
				default:
					result += b;
					break;
				}
				tc65SerialPort.serialOut(b);
				timeout = (int)System.currentTimeMillis();
			}
		}
		tc65SerialPort.serialOut("\r\n\r\nTimeout in incoming data\r\n" + 
				"WorkerThread: read " + result.length() + "bytes: " + "\r\n");
				
		// Echo the data back to the sender.
		result += "</body></html>";
		byte[] arOut = result.getBytes();
		os.write( arOut );

		tc65SerialPort.serialOut("WorkerThread: sent response, closing all\r\n");
		// Close everything.
		is.close();
		os.close();
		sc.close();
	} catch (Exception e) {
		tc65SerialPort.serialOut("WorkerThread: comms: excp: " + e.getMessage() + "\r\n");
	}	

	tc65SerialPort.serialOut("WorkerThread: exiting from run()\r\n");
	try {
		interrupt();
		tc65SerialPort.serialOut("WorkerThread: interrupt()'ed\r\n");
		join();
		tc65SerialPort.serialOut("WorkerThread: join()'ed\r\n");
	} catch (Exception e) {
		tc65SerialPort.serialOut("WorkerThread: join() failed: " + e.getMessage() + "\r\n");
	}	
}
}
